/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.facman.entityClass;

import java.io.Serializable;
import java.math.BigInteger;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

/**
 *
 * @author Noway
 */
@Entity
@Table(name = "Property", catalog = "", schema = "public", uniqueConstraints = {
    @UniqueConstraint(columnNames = {"code"})})
@NamedQueries({
    @NamedQuery(name = "Property.findAll", query = "SELECT p FROM Property p"),
    @NamedQuery(name = "Property.findByPropertyID", query = "SELECT p FROM Property p WHERE p.propertyID = :propertyID"),
    @NamedQuery(name = "Property.findByCode", query = "SELECT p FROM Property p WHERE p.code = :code"),
    @NamedQuery(name = "Property.findByName", query = "SELECT p FROM Property p WHERE p.name = :name"),
    @NamedQuery(name = "Property.findByAddress", query = "SELECT p FROM Property p WHERE p.address = :address"),
    @NamedQuery(name = "Property.findByStatus", query = "SELECT p FROM Property p WHERE p.status = :status"),
    @NamedQuery(name = "Property.findByTemplateID", query = "SELECT p FROM Property p WHERE p.templateID = :templateID")})
public class Property implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "propertyID", nullable = false)
    private Long propertyID;
    @Column(name = "code", length = 20)
    private String code;
    @Basic(optional = false)
    @Column(name = "name", nullable = false, length = 200)
    private String name;
    @Column(name = "address")
    private Serializable address;
    @Column(name = "status")
    private Short status;
    @Column(name = "templateID")
    private BigInteger templateID;

    public Property() {
    }

    public Property(Long propertyID) {
        this.propertyID = propertyID;
    }

    public Property(Long propertyID, String name) {
        this.propertyID = propertyID;
        this.name = name;
    }

    public Long getPropertyID() {
        return propertyID;
    }

    public void setPropertyID(Long propertyID) {
        this.propertyID = propertyID;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Serializable getAddress() {
        return address;
    }

    public void setAddress(Serializable address) {
        this.address = address;
    }

    public Short getStatus() {
        return status;
    }

    public void setStatus(Short status) {
        this.status = status;
    }

    public BigInteger getTemplateID() {
        return templateID;
    }

    public void setTemplateID(BigInteger templateID) {
        this.templateID = templateID;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (propertyID != null ? propertyID.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Property)) {
            return false;
        }
        Property other = (Property) object;
        if ((this.propertyID == null && other.propertyID != null) || (this.propertyID != null && !this.propertyID.equals(other.propertyID))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "org.facman.entityClass.Property[propertyID=" + propertyID + "]";
    }

}
